package com.gree.mall.manager.bean.coupon;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.gree.mall.manager.plus.entity.Coupon;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel
@Data
public class CouponVO  {

    @ApiModelProperty(value = "优惠券id")
    @TableId(value = "coupon_id", type = IdType.ID_WORKER_STR)
    private String couponId;

    @ApiModelProperty(value = "优惠券名称")
    private String couponName;

    @ApiModelProperty(value = "发放总量")
    private Integer couponAmount;

    @ApiModelProperty(value = "优惠券图片")
    private String imgSrc;

    @ApiModelProperty(value = "类型 SATISFY=满减券 DISCOUNT=折扣券 RANDOM=随机金额券  GOODS=商品券")
    private String couponType;

    @ApiModelProperty(value = "订单满足金额 0=没门槛")
    private BigDecimal orderAmount;

    @ApiModelProperty(value = "用券时间类型 1=统一指定时间 2=领券当日起多少天可用 3=领券次日起多少天可用")
    private Integer activeType;

    @ApiModelProperty(value = "多少天后过期")
    private Integer activeDay;

    @ApiModelProperty(value = "优惠券使用开始时间")
    private Date activeStartTime;

    @ApiModelProperty(value = "优惠券使用结束时间")
    private Date activeEndTime;

    @ApiModelProperty(value = "领取人群 0=所有会员 1=指定标签 2=指定会员 3=全部业务员,4=全部普通用户")
    private Integer receiveCrowd;

    @ApiModelProperty(value = "每人限领次数 0=不限次数")
    private Integer receiveLimitCount;

    @ApiModelProperty(value = "限制原价商品 false=不限制 true=限制")
    private Boolean originalPriceLimit;

    @ApiModelProperty(value = "排序(降序)")
    private Integer sortNum;

    @ApiModelProperty(value = "优惠值")
    private BigDecimal couponValue;

    @ApiModelProperty(value = "使用说明")
    private String note;

    @ApiModelProperty(value = "优惠券领取开始时间")
    private Date obtainStartTime;

    @ApiModelProperty(value = "优惠券领取结束时间")
    private Date obtainEndTime;

    @ApiModelProperty(value = "券显示时间")
    private Date displayTime;

    @ApiModelProperty(value = "发布开始时间")
    private Date releaseStartTime;

    @ApiModelProperty(value = "发布结束时间")
    private Date releaseEndTime;

    @ApiModelProperty(value = "标志 WAIT=待发布 START=进行中 END=结束 CANCEL=取消")
    private String flag;

    @ApiModelProperty(value = "领取数量")
    private Integer receiveAmount;

    @ApiModelProperty(value = "剩余数量")
    private Integer leftAmount;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "是否可以转让,1:可转让,0:不可转让")
    private Boolean transferType;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "业务员券分享次数")
    private Integer shareTimes;

    @ApiModelProperty(value = "企业微信id")
    private String companyWechatId;

    @ApiModelProperty(value = "企业名称")
    private String companyName;


}
