package com.gree.mall.manager.commonmapper;

import com.baomidou.mybatisplus.annotation.SqlParser;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.gree.mall.manager.bean.count.CountBean;
import com.gree.mall.manager.bean.count.CountOrderBean;
import com.gree.mall.manager.bean.count.GoodsRankBean;
import com.gree.mall.manager.bean.count.WebsitSaleCountBean;
import com.gree.mall.manager.bean.exchange.GiftExchangeCodeBean;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

@Mapper
public interface CountMapper {

    /**
     * 首页基础概况统计
     * @return
     */
    @SqlParser(filter = true)
    public CountBean countInfo(@Param("companyWechatIds") List<String> companyWechatIds);

    /**
     * 首页销售统计
     */
    @SqlParser(filter = true)
    public CountOrderBean countSaleOrder(@Param("startTime") String startTime,
                                         @Param("endTime") String endTime,
                                         @Param("workOrderType") String workOrderType,
                                         @Param("companyWechatIds") List<String> companyWechatIds,
                                         @Param("websitIds") List<String> websitIds);

    /**
     * 商品销量排行
     */
    @SqlParser(filter = true)
    public List<GoodsRankBean> countGoodsRank(@Param("startTime") String startTime,
                                              @Param("endTime") String endTime,
                                              @Param("companyWechatIds") List<String> companyWechatIds,
                                              @Param("websitIds") List<String> websitIds);

    /**
     * 今日昨日访问量
     */
    @SqlParser(filter = true)
    public Integer countVisit(@Param("startTime") String startTime, @Param("endTime") String endTime,@Param("companyWechatIds") List<String> companyWechatIds);


    /**
     * 师傅的销售金额统计(外部接口结算用)
     */
    @SqlParser(filter = true)
    public List<Map<String,Object>> countWorkAmount(@Param("startTime") String startTime, @Param("endTime") String endTime,@Param("companyWechatIds") List<String> companyWechatIds);

    @SqlParser(filter = true)
    public Map<String,Object> countWebsitAmount(@Param("startTime") String startTime, @Param("endTime") String endTime, @Param("websitNumbers") List<String> websitNumbers);


    /**
     *  优惠券统计列表
     */
    @SqlParser(filter = true)
    public IPage<GiftExchangeCodeBean> queryExchangeCodeCountList(IPage page,@Param("keyword") String keyword,@Param("adminWebsitId") String adminWebsitId,@Param("companyWechatIds") List<String> companyWechatIds);


}
